c0aa5f9f7d6b5828ada0873884ea3154f75d5a6f
[csit.git] / resources / libraries / bash / function / common.sh
1 # Copyright (c) 2020 Cisco and/or its affiliates.
2 # Copyright (c) 2020 PANTHEON.tech and/or its affiliates.
3 # Licensed under the Apache License, Version 2.0 (the "License");
4 # you may not use this file except in compliance with the License.
5 # You may obtain a copy of the License at:
6 #
7 #     http://www.apache.org/licenses/LICENSE-2.0
8 #
9 # Unless required by applicable law or agreed to in writing, software
10 # distributed under the License is distributed on an "AS IS" BASIS,
11 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
12 # See the License for the specific language governing permissions and
13 # limitations under the License.
14
15 set -exuo pipefail
16
17 # This library defines functions used by multiple entry scripts.
18 # Keep functions ordered alphabetically, please.
19
20 # TODO: Add a link to bash style guide.
21 # TODO: Consider putting every die into a {} block,
22 #   the code might become more readable (but longer).
23
24
25 function activate_docker_topology () {
26
27     # Create virtual vpp-device topology. Output of the function is topology
28     # file describing created environment saved to a file.
29     #
30     # Variables read:
31     # - BASH_FUNCTION_DIR - Path to existing directory this file is located in.
32     # - TOPOLOGIES - Available topologies.
33     # - NODENESS - Node multiplicity of desired testbed.
34     # - FLAVOR - Node flavor string, usually describing the processor.
35     # - IMAGE_VER_FILE - Name of file that contains the image version.
36     # - CSIT_DIR - Directory where ${IMAGE_VER_FILE} is located.
37     # Variables set:
38     # - WORKING_TOPOLOGY - Path to topology file.
39
40     set -exuo pipefail
41
42     source "${BASH_FUNCTION_DIR}/device.sh" || {
43         die "Source failed!"
44     }
45     device_image="$(< ${CSIT_DIR}/${IMAGE_VER_FILE})"
46     case_text="${NODENESS}_${FLAVOR}"
47     case "${case_text}" in
48         "1n_skx" | "1n_tx2")
49             # We execute reservation over csit-shim-dcr (ssh) which runs sourced
50             # script's functions. Env variables are read from ssh output
51             # back to localhost for further processing.
52             # Shim and Jenkins executor are in the same network on the same host
53             # Connect to docker's default gateway IP and shim's exposed port
54             ssh="ssh root@172.17.0.1 -p 6022"
55             run="activate_wrapper ${NODENESS} ${FLAVOR} ${device_image}"
56             # The "declare -f" output is long and boring.
57             set +x
58             # backtics to avoid https://midnight-commander.org/ticket/2142
59             env_vars=`${ssh} "$(declare -f); ${run}"` || {
60                 die "Topology reservation via shim-dcr failed!"
61             }
62             set -x
63             set -a
64             source <(echo "$env_vars" | grep -v /usr/bin/docker) || {
65                 die "Source failed!"
66             }
67             set +a
68             ;;
69         "1n_vbox")
70             # We execute reservation on localhost. Sourced script automatially
71             # sets environment variables for further processing.
72             activate_wrapper "${NODENESS}" "${FLAVOR}" "${device_image}" || die
73             ;;
74         *)
75             die "Unknown specification: ${case_text}!"
76     esac
77
78     trap 'deactivate_docker_topology' EXIT || {
79          die "Trap attempt failed, please cleanup manually. Aborting!"
80     }
81
82     # Replace all variables in template with those in environment.
83     source <(echo 'cat <<EOF >topo.yml'; cat ${TOPOLOGIES[0]}; echo EOF;) || {
84         die "Topology file create failed!"
85     }
86
87     WORKING_TOPOLOGY="/tmp/topology.yaml"
88     mv topo.yml "${WORKING_TOPOLOGY}" || {
89         die "Topology move failed!"
90     }
91     cat ${WORKING_TOPOLOGY} | grep -v password || {
92         die "Topology read failed!"
93     }
94 }
95
96
97 function activate_virtualenv () {
98
99     # Update virtualenv pip package, delete and create virtualenv directory,
100     # activate the virtualenv, install requirements, set PYTHONPATH.
101
102     # Arguments:
103     # - ${1} - Path to existing directory for creating virtualenv in.
104     #          If missing or empty, ${CSIT_DIR} is used.
105     # - ${2} - Path to requirements file, ${CSIT_DIR}/requirements.txt if empty.
106     # Variables read:
107     # - CSIT_DIR - Path to existing root of local CSIT git repository.
108     # Variables exported:
109     # - PYTHONPATH - CSIT_DIR, as CSIT Python scripts usually need this.
110     # Functions called:
111     # - die - Print to stderr and exit.
112
113     set -exuo pipefail
114
115     root_path="${1-$CSIT_DIR}"
116     env_dir="${root_path}/env"
117     req_path=${2-$CSIT_DIR/requirements.txt}
118     rm -rf "${env_dir}" || die "Failed to clean previous virtualenv."
119     pip3 install virtualenv==20.0.20 || {
120         die "Virtualenv package install failed."
121     }
122     virtualenv --no-download --python=$(which python3) "${env_dir}" || {
123         die "Virtualenv creation for $(which python3) failed."
124     }
125     set +u
126     source "${env_dir}/bin/activate" || die "Virtualenv activation failed."
127     set -u
128     pip3 install -r "${req_path}" || {
129         die "Requirements installation failed."
130     }
131     # Most CSIT Python scripts assume PYTHONPATH is set and exported.
132     export PYTHONPATH="${CSIT_DIR}" || die "Export failed."
133 }
134
135
136 function archive_tests () {
137
138     # Create .tar.xz of generated/tests for archiving.
139     # To be run after generate_tests, kept separate to offer more flexibility.
140
141     # Directory read:
142     # - ${GENERATED_DIR}/tests - Tree of executed suites to archive.
143     # File rewriten:
144     # - ${ARCHIVE_DIR}/tests.tar.xz - Archive of generated tests.
145
146     set -exuo pipefail
147
148     tar c "${GENERATED_DIR}/tests" | xz -3 > "${ARCHIVE_DIR}/tests.tar.xz" || {
149         die "Error creating archive of generated tests."
150     }
151 }
152
153
154 function check_download_dir () {
155
156     # Fail if there are no files visible in ${DOWNLOAD_DIR}.
157     #
158     # Variables read:
159     # - DOWNLOAD_DIR - Path to directory pybot takes the build to test from.
160     # Directories read:
161     # - ${DOWNLOAD_DIR} - Has to be non-empty to proceed.
162     # Functions called:
163     # - die - Print to stderr and exit.
164
165     set -exuo pipefail
166
167     if [[ ! "$(ls -A "${DOWNLOAD_DIR}")" ]]; then
168         die "No artifacts downloaded!"
169     fi
170 }
171
172
173 function check_prerequisites () {
174
175     # Fail if prerequisites are not met.
176     #
177     # Functions called:
178     # - installed - Check if application is installed/present in system.
179     # - die - Print to stderr and exit.
180
181     set -exuo pipefail
182
183     if ! installed sshpass; then
184         die "Please install sshpass before continue!"
185     fi
186 }
187
188
189 function common_dirs () {
190
191     # Set global variables, create some directories (without touching content).
192
193     # Variables set:
194     # - BASH_FUNCTION_DIR - Path to existing directory this file is located in.
195     # - CSIT_DIR - Path to existing root of local CSIT git repository.
196     # - TOPOLOGIES_DIR - Path to existing directory with available topologies.
197     # - JOB_SPECS_DIR - Path to existing directory with job test specifications.
198     # - RESOURCES_DIR - Path to existing CSIT subdirectory "resources".
199     # - TOOLS_DIR - Path to existing resources subdirectory "tools".
200     # - PYTHON_SCRIPTS_DIR - Path to existing tools subdirectory "scripts".
201     # - ARCHIVE_DIR - Path to created CSIT subdirectory "archives".
202     #   The name is chosen to match what ci-management expects.
203     # - DOWNLOAD_DIR - Path to created CSIT subdirectory "download_dir".
204     # - GENERATED_DIR - Path to created CSIT subdirectory "generated".
205     # Directories created if not present:
206     # ARCHIVE_DIR, DOWNLOAD_DIR, GENERATED_DIR.
207     # Functions called:
208     # - die - Print to stderr and exit.
209
210     set -exuo pipefail
211
212     this_file=$(readlink -e "${BASH_SOURCE[0]}") || {
213         die "Some error during locating of this source file."
214     }
215     BASH_FUNCTION_DIR=$(dirname "${this_file}") || {
216         die "Some error during dirname call."
217     }
218     # Current working directory could be in a different repo, e.g. VPP.
219     pushd "${BASH_FUNCTION_DIR}" || die "Pushd failed"
220     relative_csit_dir=$(git rev-parse --show-toplevel) || {
221         die "Git rev-parse failed."
222     }
223     CSIT_DIR=$(readlink -e "${relative_csit_dir}") || die "Readlink failed."
224     popd || die "Popd failed."
225     TOPOLOGIES_DIR=$(readlink -e "${CSIT_DIR}/topologies/available") || {
226         die "Readlink failed."
227     }
228     JOB_SPECS_DIR=$(readlink -e "${CSIT_DIR}/docs/job_specs") || {
229         die "Readlink failed."
230     }
231     RESOURCES_DIR=$(readlink -e "${CSIT_DIR}/resources") || {
232         die "Readlink failed."
233     }
234     TOOLS_DIR=$(readlink -e "${RESOURCES_DIR}/tools") || {
235         die "Readlink failed."
236     }
237     DOC_GEN_DIR=$(readlink -e "${TOOLS_DIR}/doc_gen") || {
238         die "Readlink failed."
239     }
240     PYTHON_SCRIPTS_DIR=$(readlink -e "${TOOLS_DIR}/scripts") || {
241         die "Readlink failed."
242     }
243
244     ARCHIVE_DIR=$(readlink -f "${CSIT_DIR}/archives") || {
245         die "Readlink failed."
246     }
247     mkdir -p "${ARCHIVE_DIR}" || die "Mkdir failed."
248     DOWNLOAD_DIR=$(readlink -f "${CSIT_DIR}/download_dir") || {
249         die "Readlink failed."
250     }
251     mkdir -p "${DOWNLOAD_DIR}" || die "Mkdir failed."
252     GENERATED_DIR=$(readlink -f "${CSIT_DIR}/generated") || {
253         die "Readlink failed."
254     }
255     mkdir -p "${GENERATED_DIR}" || die "Mkdir failed."
256 }
257
258
259 function compose_pybot_arguments () {
260
261     # Variables read:
262     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
263     # - DUT - CSIT test/ subdirectory, set while processing tags.
264     # - TAGS - Array variable holding selected tag boolean expressions.
265     # - TOPOLOGIES_TAGS - Tag boolean expression filtering tests for topology.
266     # - TEST_CODE - The test selection string from environment or argument.
267     # Variables set:
268     # - PYBOT_ARGS - String holding part of all arguments for pybot.
269     # - EXPANDED_TAGS - Array of strings pybot arguments compiled from tags.
270
271     set -exuo pipefail
272
273     # No explicit check needed with "set -u".
274     PYBOT_ARGS=("--loglevel" "TRACE")
275     PYBOT_ARGS+=("--variable" "TOPOLOGY_PATH:${WORKING_TOPOLOGY}")
276
277     case "${TEST_CODE}" in
278         *"device"*)
279             PYBOT_ARGS+=("--suite" "tests.${DUT}.device")
280             ;;
281         *"perf"*)
282             PYBOT_ARGS+=("--suite" "tests.${DUT}.perf")
283             ;;
284         *)
285             die "Unknown specification: ${TEST_CODE}"
286     esac
287
288     EXPANDED_TAGS=()
289     for tag in "${TAGS[@]}"; do
290         if [[ ${tag} == "!"* ]]; then
291             EXPANDED_TAGS+=("--exclude" "${tag#$"!"}")
292         else
293             EXPANDED_TAGS+=("--include" "${TOPOLOGIES_TAGS}AND${tag}")
294         fi
295     done
296 }
297
298
299 function deactivate_docker_topology () {
300
301     # Deactivate virtual vpp-device topology by removing containers.
302     #
303     # Variables read:
304     # - NODENESS - Node multiplicity of desired testbed.
305     # - FLAVOR - Node flavor string, usually describing the processor.
306
307     set -exuo pipefail
308
309     case_text="${NODENESS}_${FLAVOR}"
310     case "${case_text}" in
311         "1n_skx" | "1n_tx2")
312             ssh="ssh root@172.17.0.1 -p 6022"
313             env_vars=$(env | grep CSIT_ | tr '\n' ' ' ) || die
314             # The "declare -f" output is long and boring.
315             set +x
316             ${ssh} "$(declare -f); deactivate_wrapper ${env_vars}" || {
317                 die "Topology cleanup via shim-dcr failed!"
318             }
319             set -x
320             ;;
321         "1n_vbox")
322             enter_mutex || die
323             clean_environment || {
324                 die "Topology cleanup locally failed!"
325             }
326             exit_mutex || die
327             ;;
328         *)
329             die "Unknown specification: ${case_text}!"
330     esac
331 }
332
333
334 function die () {
335
336     # Print the message to standard error end exit with error code specified
337     # by the second argument.
338     #
339     # Hardcoded values:
340     # - The default error message.
341     # Arguments:
342     # - ${1} - The whole error message, be sure to quote. Optional
343     # - ${2} - the code to exit with, default: 1.
344
345     set -x
346     set +eu
347     warn "${1:-Unspecified run-time error occurred!}"
348     exit "${2:-1}"
349 }
350
351
352 function die_on_pybot_error () {
353
354     # Source this fragment if you want to abort on any failed test case.
355     #
356     # Variables read:
357     # - PYBOT_EXIT_STATUS - Set by a pybot running fragment.
358     # Functions called:
359     # - die - Print to stderr and exit.
360
361     set -exuo pipefail
362
363     if [[ "${PYBOT_EXIT_STATUS}" != "0" ]]; then
364         die "Test failures are present!" "${PYBOT_EXIT_STATUS}"
365     fi
366 }
367
368
369 function generate_tests () {
370
371     # Populate ${GENERATED_DIR}/tests based on ${CSIT_DIR}/tests/.
372     # Any previously existing content of ${GENERATED_DIR}/tests is wiped before.
373     # The generation is done by executing any *.py executable
374     # within any subdirectory after copying.
375
376     # This is a separate function, because this code is called
377     # both by autogen checker and entries calling run_pybot.
378
379     # Directories read:
380     # - ${CSIT_DIR}/tests - Used as templates for the generated tests.
381     # Directories replaced:
382     # - ${GENERATED_DIR}/tests - Overwritten by the generated tests.
383
384     set -exuo pipefail
385
386     rm -rf "${GENERATED_DIR}/tests" || die
387     cp -r "${CSIT_DIR}/tests" "${GENERATED_DIR}/tests" || die
388     cmd_line=("find" "${GENERATED_DIR}/tests" "-type" "f")
389     cmd_line+=("-executable" "-name" "*.py")
390     # We sort the directories, so log output can be compared between runs.
391     file_list=$("${cmd_line[@]}" | sort) || die
392
393     for gen in ${file_list}; do
394         directory="$(dirname "${gen}")" || die
395         filename="$(basename "${gen}")" || die
396         pushd "${directory}" || die
397         ./"${filename}" || die
398         popd || die
399     done
400 }
401
402
403 function get_test_code () {
404
405     # Arguments:
406     # - ${1} - Optional, argument of entry script (or empty as unset).
407     #   Test code value to override job name from environment.
408     # Variables read:
409     # - JOB_NAME - String affecting test selection, default if not argument.
410     # Variables set:
411     # - TEST_CODE - The test selection string from environment or argument.
412     # - NODENESS - Node multiplicity of desired testbed.
413     # - FLAVOR - Node flavor string, usually describing the processor.
414
415     set -exuo pipefail
416
417     TEST_CODE="${1-}" || die "Reading optional argument failed, somehow."
418     if [[ -z "${TEST_CODE}" ]]; then
419         TEST_CODE="${JOB_NAME-}" || die "Reading job name failed, somehow."
420     fi
421
422     case "${TEST_CODE}" in
423         *"1n-vbox"*)
424             NODENESS="1n"
425             FLAVOR="vbox"
426             ;;
427         *"1n-skx"*)
428             NODENESS="1n"
429             FLAVOR="skx"
430             ;;
431        *"1n-tx2"*)
432             NODENESS="1n"
433             FLAVOR="tx2"
434             ;;
435         *"2n-skx"*)
436             NODENESS="2n"
437             FLAVOR="skx"
438             ;;
439         *"2n-zn2"*)
440             NODENESS="2n"
441             FLAVOR="zn2"
442             ;;
443         *"3n-skx"*)
444             NODENESS="3n"
445             FLAVOR="skx"
446             ;;
447         *"2n-clx"*)
448             NODENESS="2n"
449             FLAVOR="clx"
450             ;;
451         *"2n-dnv"*)
452             NODENESS="2n"
453             FLAVOR="dnv"
454             ;;
455         *"3n-dnv"*)
456             NODENESS="3n"
457             FLAVOR="dnv"
458             ;;
459         *"3n-tsh"*)
460             NODENESS="3n"
461             FLAVOR="tsh"
462             ;;
463         *)
464             # Fallback to 3-node Haswell by default (backward compatibility)
465             NODENESS="3n"
466             FLAVOR="hsw"
467             ;;
468     esac
469 }
470
471
472 function get_test_tag_string () {
473
474     # Variables read:
475     # - GERRIT_EVENT_TYPE - Event type set by gerrit, can be unset.
476     # - GERRIT_EVENT_COMMENT_TEXT - Comment text, read for "comment-added" type.
477     # - TEST_CODE - The test selection string from environment or argument.
478     # Variables set:
479     # - TEST_TAG_STRING - The string following trigger word in gerrit comment.
480     #   May be empty, or even not set on event types not adding comment.
481
482     # TODO: ci-management scripts no longer need to perform this.
483
484     set -exuo pipefail
485
486     if [[ "${GERRIT_EVENT_TYPE-}" == "comment-added" ]]; then
487         case "${TEST_CODE}" in
488             *"device"*)
489                 trigger="devicetest"
490                 ;;
491             *"perf"*)
492                 trigger="perftest"
493                 ;;
494             *)
495                 die "Unknown specification: ${TEST_CODE}"
496         esac
497         # Ignore lines not containing the trigger word.
498         comment=$(fgrep "${trigger}" <<< "${GERRIT_EVENT_COMMENT_TEXT}" || true)
499         # The vpp-csit triggers trail stuff we are not interested in.
500         # Removing them and trigger word: https://unix.stackexchange.com/a/13472
501         # (except relying on \s whitespace, \S non-whitespace and . both).
502         # The last string is concatenated, only the middle part is expanded.
503         cmd=("grep" "-oP" '\S*'"${trigger}"'\S*\s\K.+$') || die "Unset trigger?"
504         # On parsing error, TEST_TAG_STRING probably stays empty.
505         TEST_TAG_STRING=$("${cmd[@]}" <<< "${comment}" || true)
506         if [[ -z "${TEST_TAG_STRING-}" ]]; then
507             # Probably we got a base64 encoded comment.
508             comment=$(base64 --decode <<< "${GERRIT_EVENT_COMMENT_TEXT}" || true)
509             comment=$(fgrep "${trigger}" <<< "${comment}" || true)
510             TEST_TAG_STRING=$("${cmd[@]}" <<< "${comment}" || true)
511         fi
512         if [[ -n "${TEST_TAG_STRING-}" ]]; then
513             test_tag_array=(${TEST_TAG_STRING})
514             if [[ "${test_tag_array[0]}" == "icl" ]]; then
515                 export GRAPH_NODE_VARIANT="icl"
516                 TEST_TAG_STRING="${test_tag_array[@]:1}" || true
517             elif [[ "${test_tag_array[0]}" == "skx" ]]; then
518                 export GRAPH_NODE_VARIANT="skx"
519                 TEST_TAG_STRING="${test_tag_array[@]:1}" || true
520             elif [[ "${test_tag_array[0]}" == "hsw" ]]; then
521                 export GRAPH_NODE_VARIANT="hsw"
522                 TEST_TAG_STRING="${test_tag_array[@]:1}" || true
523             fi
524         fi
525     fi
526 }
527
528
529 function installed () {
530
531     # Check if the given utility is installed. Fail if not installed.
532     #
533     # Duplicate of common.sh function, as this file is also used standalone.
534     #
535     # Arguments:
536     # - ${1} - Utility to check.
537     # Returns:
538     # - 0 - If command is installed.
539     # - 1 - If command is not installed.
540
541     set -exuo pipefail
542
543     command -v "${1}"
544 }
545
546
547 function move_archives () {
548
549     # Move archive directory to top of workspace, if not already there.
550     #
551     # ARCHIVE_DIR is positioned relative to CSIT_DIR,
552     # but in some jobs CSIT_DIR is not same as WORKSPACE
553     # (e.g. under VPP_DIR). To simplify ci-management settings,
554     # we want to move the data to the top. We do not want simple copy,
555     # as ci-management is eager with recursive search.
556     #
557     # As some scripts may call this function multiple times,
558     # the actual implementation use copying and deletion,
559     # so the workspace gets "union" of contents (except overwrites on conflict).
560     # The consequence is empty ARCHIVE_DIR remaining after this call.
561     #
562     # As the source directory is emptied,
563     # the check for dirs being different is essential.
564     #
565     # Variables read:
566     # - WORKSPACE - Jenkins workspace, move only if the value is not empty.
567     #   Can be unset, then it speeds up manual testing.
568     # - ARCHIVE_DIR - Path to directory with content to be moved.
569     # Directories updated:
570     # - ${WORKSPACE}/archives/ - Created if does not exist.
571     #   Content of ${ARCHIVE_DIR}/ is moved.
572     # Functions called:
573     # - die - Print to stderr and exit.
574
575     set -exuo pipefail
576
577     if [[ -n "${WORKSPACE-}" ]]; then
578         target=$(readlink -f "${WORKSPACE}/archives")
579         if [[ "${target}" != "${ARCHIVE_DIR}" ]]; then
580             mkdir -p "${target}" || die "Archives dir create failed."
581             cp -rf "${ARCHIVE_DIR}"/* "${target}" || die "Copy failed."
582             rm -rf "${ARCHIVE_DIR}"/* || die "Delete failed."
583         fi
584     fi
585 }
586
587
588 function reserve_and_cleanup_testbed () {
589
590     # Reserve physical testbed, perform cleanup, register trap to unreserve.
591     # When cleanup fails, remove from topologies and keep retrying
592     # until all topologies are removed.
593     #
594     # Variables read:
595     # - TOPOLOGIES - Array of paths to topology yaml to attempt reservation on.
596     # - PYTHON_SCRIPTS_DIR - Path to directory holding the reservation script.
597     # - BUILD_TAG - Any string suitable as filename, identifying
598     #   test run executing this function. May be unset.
599     # Variables set:
600     # - TOPOLOGIES - Array of paths to topologies, with failed cleanups removed.
601     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
602     # Functions called:
603     # - die - Print to stderr and exit.
604     # - ansible_playbook - Perform an action using ansible, see ansible.sh
605     # Traps registered:
606     # - EXIT - Calls cancel_all for ${WORKING_TOPOLOGY}.
607
608     set -exuo pipefail
609
610     while true; do
611         for topo in "${TOPOLOGIES[@]}"; do
612             set +e
613             scrpt="${PYTHON_SCRIPTS_DIR}/topo_reservation.py"
614             opts=("-t" "${topo}" "-r" "${BUILD_TAG:-Unknown}")
615             python3 "${scrpt}" "${opts[@]}"
616             result="$?"
617             set -e
618             if [[ "${result}" == "0" ]]; then
619                 # Trap unreservation before cleanup check,
620                 # so multiple jobs showing failed cleanup improve chances
621                 # of humans to notice and fix.
622                 WORKING_TOPOLOGY="${topo}"
623                 echo "Reserved: ${WORKING_TOPOLOGY}"
624                 trap "untrap_and_unreserve_testbed" EXIT || {
625                     message="TRAP ATTEMPT AND UNRESERVE FAILED, FIX MANUALLY."
626                     untrap_and_unreserve_testbed "${message}" || {
627                         die "Teardown should have died, not failed."
628                     }
629                     die "Trap attempt failed, unreserve succeeded. Aborting."
630                 }
631                 # Cleanup + calibration checks.
632                 set +e
633                 ansible_playbook "cleanup, calibration"
634                 result="$?"
635                 set -e
636                 if [[ "${result}" == "0" ]]; then
637                     break
638                 fi
639                 warn "Testbed cleanup failed: ${topo}"
640                 untrap_and_unreserve_testbed "Fail of unreserve after cleanup."
641             fi
642             # Else testbed is accessible but currently reserved, moving on.
643         done
644
645         if [[ -n "${WORKING_TOPOLOGY-}" ]]; then
646             # Exit the infinite while loop if we made a reservation.
647             warn "Reservation and cleanup successful."
648             break
649         fi
650
651         if [[ "${#TOPOLOGIES[@]}" == "0" ]]; then
652             die "Run out of operational testbeds!"
653         fi
654
655         # Wait ~3minutes before next try.
656         sleep_time="$[ ( ${RANDOM} % 20 ) + 180 ]s" || {
657             die "Sleep time calculation failed."
658         }
659         echo "Sleeping ${sleep_time}"
660         sleep "${sleep_time}" || die "Sleep failed."
661     done
662 }
663
664
665 function run_pybot () {
666
667     # Run pybot with options based on input variables. Create output_info.xml
668     #
669     # Variables read:
670     # - CSIT_DIR - Path to existing root of local CSIT git repository.
671     # - ARCHIVE_DIR - Path to store robot result files in.
672     # - PYBOT_ARGS, EXPANDED_TAGS - See compose_pybot_arguments.sh
673     # - GENERATED_DIR - Tests are assumed to be generated under there.
674     # Variables set:
675     # - PYBOT_EXIT_STATUS - Exit status of most recent pybot invocation.
676     # Functions called:
677     # - die - Print to stderr and exit.
678
679     set -exuo pipefail
680
681     all_options=("--outputdir" "${ARCHIVE_DIR}" "${PYBOT_ARGS[@]}")
682     all_options+=("--noncritical" "EXPECTED_FAILING")
683     all_options+=("${EXPANDED_TAGS[@]}")
684
685     pushd "${CSIT_DIR}" || die "Change directory operation failed."
686     set +e
687     robot "${all_options[@]}" "${GENERATED_DIR}/tests/"
688     PYBOT_EXIT_STATUS="$?"
689     set -e
690
691     # Generate INFO level output_info.xml for post-processing.
692     all_options=("--loglevel" "INFO")
693     all_options+=("--log" "none")
694     all_options+=("--report" "none")
695     all_options+=("--output" "${ARCHIVE_DIR}/output_info.xml")
696     all_options+=("${ARCHIVE_DIR}/output.xml")
697     rebot "${all_options[@]}" || true
698     popd || die "Change directory operation failed."
699 }
700
701
702 function select_arch_os () {
703
704     # Set variables affected by local CPU architecture and operating system.
705     #
706     # Variables set:
707     # - VPP_VER_FILE - Name of file in CSIT dir containing vpp stable version.
708     # - IMAGE_VER_FILE - Name of file in CSIT dir containing the image name.
709     # - PKG_SUFFIX - Suffix of OS package file name, "rpm" or "deb."
710
711     set -exuo pipefail
712
713     os_id=$(grep '^ID=' /etc/os-release | cut -f2- -d= | sed -e 's/\"//g') || {
714         die "Get OS release failed."
715     }
716
717     case "${os_id}" in
718         "ubuntu"*)
719             IMAGE_VER_FILE="VPP_DEVICE_IMAGE_UBUNTU"
720             VPP_VER_FILE="VPP_STABLE_VER_UBUNTU_BIONIC"
721             PKG_SUFFIX="deb"
722             ;;
723         "centos"*)
724             IMAGE_VER_FILE="VPP_DEVICE_IMAGE_CENTOS"
725             VPP_VER_FILE="VPP_STABLE_VER_CENTOS"
726             PKG_SUFFIX="rpm"
727             ;;
728         *)
729             die "Unable to identify distro or os from ${os_id}"
730             ;;
731     esac
732
733     arch=$(uname -m) || {
734         die "Get CPU architecture failed."
735     }
736
737     case "${arch}" in
738         "aarch64")
739             IMAGE_VER_FILE="${IMAGE_VER_FILE}_ARM"
740             ;;
741         *)
742             ;;
743     esac
744 }
745
746
747 function select_tags () {
748
749     # Variables read:
750     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
751     # - TEST_CODE - String affecting test selection, usually jenkins job name.
752     # - DUT - CSIT test/ subdirectory, set while processing tags.
753     # - TEST_TAG_STRING - String selecting tags, from gerrit comment.
754     #   Can be unset.
755     # - TOPOLOGIES_DIR - Path to existing directory with available tpologies.
756     # - BASH_FUNCTION_DIR - Directory with input files to process.
757     # Variables set:
758     # - TAGS - Array of processed tag boolean expressions.
759
760     set -exuo pipefail
761
762     # NIC SELECTION
763     start_pattern='^  TG:'
764     end_pattern='^ \? \?[A-Za-z0-9]\+:'
765     # Remove the TG section from topology file
766     sed_command="/${start_pattern}/,/${end_pattern}/d"
767     # All topologies DUT NICs
768     available=$(sed "${sed_command}" "${TOPOLOGIES_DIR}"/* \
769                 | grep -hoP "model: \K.*" | sort -u)
770     # Selected topology DUT NICs
771     reserved=$(sed "${sed_command}" "${WORKING_TOPOLOGY}" \
772                | grep -hoP "model: \K.*" | sort -u)
773     # All topologies DUT NICs - Selected topology DUT NICs
774     exclude_nics=($(comm -13 <(echo "${reserved}") <(echo "${available}"))) || {
775         die "Computation of excluded NICs failed."
776     }
777
778     # Select default NIC tag.
779     case "${TEST_CODE}" in
780         *"3n-dnv"* | *"2n-dnv"*)
781             default_nic="nic_intel-x553"
782             ;;
783         *"3n-tsh"*)
784             default_nic="nic_intel-x520-da2"
785             ;;
786         *"3n-skx"* | *"2n-skx"* | *"2n-clx"* | *"2n-zn2"*)
787             default_nic="nic_intel-xxv710"
788             ;;
789         *"3n-hsw"* | *"mrr-daily-master")
790             default_nic="nic_intel-xl710"
791             ;;
792         *)
793             default_nic="nic_intel-x710"
794             ;;
795     esac
796
797     sed_nic_sub_cmd="sed s/\${default_nic}/${default_nic}/"
798     sed_nics_sub_cmd="sed -e s/ANDxxv710/ANDnic_intel-xxv710/"
799     sed_nics_sub_cmd+=" | sed -e s/ANDx710/ANDnic_intel-x710/"
800     sed_nics_sub_cmd+=" | sed -e s/ANDxl710/ANDnic_intel-xl710/"
801     sed_nics_sub_cmd+=" | sed -e s/ANDx520-da2/ANDnic_intel-x520-da2/"
802     sed_nics_sub_cmd+=" | sed -e s/ANDx553/ANDnic_intel-x553/"
803     sed_nics_sub_cmd+=" | sed -e s/ANDcx556a/ANDnic_mellanox-cx556a/"
804     sed_nics_sub_cmd+=" | sed -e s/ANDvic1227/ANDnic_cisco-vic-1227/"
805     sed_nics_sub_cmd+=" | sed -e s/ANDvic1385/ANDnic_cisco-vic-1385/"
806     # Tag file directory shorthand.
807     tfd="${JOB_SPECS_DIR}"
808     case "${TEST_CODE}" in
809         # Select specific performance tests based on jenkins job type variable.
810         *"ndrpdr-weekly"* )
811             readarray -t test_tag_array <<< $(sed 's/ //g' \
812                 ${tfd}/mlr_weekly/${DUT}-${NODENESS}-${FLAVOR}.md |
813                 eval ${sed_nics_sub_cmd} || echo "perftest") || die
814             ;;
815         *"mrr-daily"* )
816             readarray -t test_tag_array <<< $(sed 's/ //g' \
817                 ${tfd}/mrr_daily/${DUT}-${NODENESS}-${FLAVOR}.md |
818                 eval ${sed_nics_sub_cmd} || echo "perftest") || die
819             ;;
820         *"mrr-weekly"* )
821             readarray -t test_tag_array <<< $(sed 's/ //g' \
822                 ${tfd}/mrr_weekly/${DUT}-${NODENESS}-${FLAVOR}.md |
823                 eval ${sed_nics_sub_cmd} || echo "perftest") || die
824             ;;
825         *"report-iterative"* )
826             test_sets=(${TEST_TAG_STRING//:/ })
827             # Run only one test set per run
828             report_file=${test_sets[0]}.md
829             readarray -t test_tag_array <<< $(sed 's/ //g' \
830                 ${tfd}/report_iterative/${NODENESS}-${FLAVOR}/${report_file} |
831                 eval ${sed_nics_sub_cmd} || echo "perftest") || die
832             ;;
833         *"report-coverage"* )
834             test_sets=(${TEST_TAG_STRING//:/ })
835             # Run only one test set per run
836             report_file=${test_sets[0]}.md
837             readarray -t test_tag_array <<< $(sed 's/ //g' \
838                 ${tfd}/report_coverage/${NODENESS}-${FLAVOR}/${report_file} |
839                 eval ${sed_nics_sub_cmd} || echo "perftest") || die
840             ;;
841         * )
842             if [[ -z "${TEST_TAG_STRING-}" ]]; then
843                 # If nothing is specified, we will run pre-selected tests by
844                 # following tags.
845                 test_tag_array=("mrrAND${default_nic}AND1cAND64bANDip4base"
846                                 "mrrAND${default_nic}AND1cAND78bANDip6base"
847                                 "mrrAND${default_nic}AND1cAND64bANDl2bdbase"
848                                 "mrrAND${default_nic}AND1cAND64bANDl2xcbase"
849                                 "!dot1q" "!drv_avf")
850             else
851                 # If trigger contains tags, split them into array.
852                 test_tag_array=(${TEST_TAG_STRING//:/ })
853             fi
854             ;;
855     esac
856
857     # Blacklisting certain tags per topology.
858     #
859     # Reasons for blacklisting:
860     # - ipsechw - Blacklisted on testbeds without crypto hardware accelerator.
861     # TODO: Add missing reasons here (if general) or where used (if specific).
862     case "${TEST_CODE}" in
863         *"2n-skx"*)
864             test_tag_array+=("!ipsec")
865             ;;
866         *"3n-skx"*)
867             test_tag_array+=("!ipsechw")
868             # Not enough nic_intel-xxv710 to support double link tests.
869             test_tag_array+=("!3_node_double_link_topoANDnic_intel-xxv710")
870             ;;
871         *"2n-clx"*)
872             test_tag_array+=("!ipsec")
873             ;;
874         *"2n-zn2"*)
875             test_tag_array+=("!ipsec")
876             ;;
877         *"2n-dnv"*)
878             test_tag_array+=("!ipsechw")
879             test_tag_array+=("!memif")
880             test_tag_array+=("!srv6_proxy")
881             test_tag_array+=("!vhost")
882             test_tag_array+=("!vts")
883             test_tag_array+=("!drv_avf")
884             ;;
885         *"3n-dnv"*)
886             test_tag_array+=("!memif")
887             test_tag_array+=("!srv6_proxy")
888             test_tag_array+=("!vhost")
889             test_tag_array+=("!vts")
890             test_tag_array+=("!drv_avf")
891             ;;
892         *"3n-tsh"*)
893             # 3n-tsh only has x520 NICs which don't work with AVF
894             test_tag_array+=("!drv_avf")
895             test_tag_array+=("!ipsechw")
896             ;;
897         *"3n-hsw"*)
898             test_tag_array+=("!drv_avf")
899             # All cards have access to QAT. But only one card (xl710)
900             # resides in same NUMA as QAT. Other cards must go over QPI
901             # which we do not want to even run.
902             test_tag_array+=("!ipsechwNOTnic_intel-xl710")
903             ;;
904         *)
905             # Default to 3n-hsw due to compatibility.
906             test_tag_array+=("!drv_avf")
907             test_tag_array+=("!ipsechwNOTnic_intel-xl710")
908             ;;
909     esac
910
911     # We will add excluded NICs.
912     test_tag_array+=("${exclude_nics[@]/#/!NIC_}")
913
914     TAGS=()
915
916     # We will prefix with perftest to prevent running other tests
917     # (e.g. Functional).
918     prefix="perftestAND"
919     set +x
920     if [[ "${TEST_CODE}" == "vpp-"* ]]; then
921         # Automatic prefixing for VPP jobs to limit the NIC used and
922         # traffic evaluation to MRR.
923         if [[ "${TEST_TAG_STRING-}" == *"nic_"* ]]; then
924             prefix="${prefix}mrrAND"
925         else
926             prefix="${prefix}mrrAND${default_nic}AND"
927         fi
928     fi
929     for tag in "${test_tag_array[@]}"; do
930         if [[ "${tag}" == "!"* ]]; then
931             # Exclude tags are not prefixed.
932             TAGS+=("${tag}")
933         elif [[ "${tag}" == " "* || "${tag}" == *"perftest"* ]]; then
934             # Badly formed tag expressions can trigger way too much tests.
935             set -x
936             warn "The following tag expression hints at bad trigger: ${tag}"
937             warn "Possible cause: Multiple triggers in a single comment."
938             die "Aborting to avoid triggering too many tests."
939         elif [[ "${tag}" == *"OR"* ]]; then
940             # If OR had higher precedence than AND, it would be useful here.
941             # Some people think it does, thus triggering way too much tests.
942             set -x
943             warn "The following tag expression hints at bad trigger: ${tag}"
944             warn "Operator OR has lower precedence than AND. Use space instead."
945             die "Aborting to avoid triggering too many tests."
946         elif [[ "${tag}" != "" && "${tag}" != "#"* ]]; then
947             # Empty and comment lines are skipped.
948             # Other lines are normal tags, they are to be prefixed.
949             TAGS+=("${prefix}${tag}")
950         fi
951     done
952     set -x
953 }
954
955
956 function select_topology () {
957
958     # Variables read:
959     # - NODENESS - Node multiplicity of testbed, either "2n" or "3n".
960     # - FLAVOR - Node flavor string, currently either "hsw" or "skx".
961     # - CSIT_DIR - Path to existing root of local CSIT git repository.
962     # - TOPOLOGIES_DIR - Path to existing directory with available topologies.
963     # Variables set:
964     # - TOPOLOGIES - Array of paths to suitable topology yaml files.
965     # - TOPOLOGIES_TAGS - Tag expression selecting tests for the topology.
966     # Functions called:
967     # - die - Print to stderr and exit.
968
969     set -exuo pipefail
970
971     case_text="${NODENESS}_${FLAVOR}"
972     case "${case_text}" in
973         # TODO: Move tags to "# Blacklisting certain tags per topology" section.
974         # TODO: Double link availability depends on NIC used.
975         "1n_vbox")
976             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*vpp_device*.template )
977             TOPOLOGIES_TAGS="2_node_single_link_topo"
978             ;;
979         "1n_skx" | "1n_tx2")
980             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*vpp_device*.template )
981             TOPOLOGIES_TAGS="2_node_single_link_topo"
982             ;;
983         "2n_skx")
984             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_skx*.yaml )
985             TOPOLOGIES_TAGS="2_node_*_link_topo"
986             ;;
987         "2n_zn2")
988             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_zn2*.yaml )
989             TOPOLOGIES_TAGS="2_node_*_link_topo"
990             ;;
991         "3n_skx")
992             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_skx*.yaml )
993             TOPOLOGIES_TAGS="3_node_*_link_topo"
994             ;;
995         "2n_clx")
996             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_clx*.yaml )
997             TOPOLOGIES_TAGS="2_node_*_link_topo"
998             ;;
999         "2n_dnv")
1000             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_dnv*.yaml )
1001             TOPOLOGIES_TAGS="2_node_single_link_topo"
1002             ;;
1003         "3n_dnv")
1004             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_dnv*.yaml )
1005             TOPOLOGIES_TAGS="3_node_single_link_topo"
1006             ;;
1007         "3n_hsw")
1008             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_hsw*.yaml )
1009             TOPOLOGIES_TAGS="3_node_single_link_topo"
1010             ;;
1011         "3n_tsh")
1012             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_tsh*.yaml )
1013             TOPOLOGIES_TAGS="3_node_single_link_topo"
1014             ;;
1015         *)
1016             # No falling back to 3n_hsw default, that should have been done
1017             # by the function which has set NODENESS and FLAVOR.
1018             die "Unknown specification: ${case_text}"
1019     esac
1020
1021     if [[ -z "${TOPOLOGIES-}" ]]; then
1022         die "No applicable topology found!"
1023     fi
1024 }
1025
1026
1027 function select_vpp_device_tags () {
1028
1029     # Variables read:
1030     # - TEST_CODE - String affecting test selection, usually jenkins job name.
1031     # - TEST_TAG_STRING - String selecting tags, from gerrit comment.
1032     #   Can be unset.
1033     # Variables set:
1034     # - TAGS - Array of processed tag boolean expressions.
1035
1036     set -exuo pipefail
1037
1038     case "${TEST_CODE}" in
1039         # Select specific device tests based on jenkins job type variable.
1040         * )
1041             if [[ -z "${TEST_TAG_STRING-}" ]]; then
1042                 # If nothing is specified, we will run pre-selected tests by
1043                 # following tags. Items of array will be concatenated by OR
1044                 # in Robot Framework.
1045                 test_tag_array=()
1046             else
1047                 # If trigger contains tags, split them into array.
1048                 test_tag_array=(${TEST_TAG_STRING//:/ })
1049             fi
1050             ;;
1051     esac
1052
1053     # Blacklisting certain tags per topology.
1054     #
1055     # Reasons for blacklisting:
1056     # - avf - AVF is not possible to run on enic driver of VirtualBox.
1057     # - vhost - VirtualBox does not support nesting virtualization on Intel CPU.
1058     case "${TEST_CODE}" in
1059         *"1n-vbox"*)
1060             test_tag_array+=("!avf")
1061             test_tag_array+=("!vhost")
1062             ;;
1063         *)
1064             ;;
1065     esac
1066
1067     TAGS=()
1068
1069     # We will prefix with devicetest to prevent running other tests
1070     # (e.g. Functional).
1071     prefix="devicetestAND"
1072     if [[ "${TEST_CODE}" == "vpp-"* ]]; then
1073         # Automatic prefixing for VPP jobs to limit testing.
1074         prefix="${prefix}"
1075     fi
1076     for tag in "${test_tag_array[@]}"; do
1077         if [[ ${tag} == "!"* ]]; then
1078             # Exclude tags are not prefixed.
1079             TAGS+=("${tag}")
1080         else
1081             TAGS+=("${prefix}${tag}")
1082         fi
1083     done
1084 }
1085
1086 function untrap_and_unreserve_testbed () {
1087
1088     # Use this as a trap function to ensure testbed does not remain reserved.
1089     # Perhaps call directly before script exit, to free testbed for other jobs.
1090     # This function is smart enough to avoid multiple unreservations (so safe).
1091     # Topo cleanup is executed (call it best practice), ignoring failures.
1092     #
1093     # Hardcoded values:
1094     # - default message to die with if testbed might remain reserved.
1095     # Arguments:
1096     # - ${1} - Message to die with if unreservation fails. Default hardcoded.
1097     # Variables read (by inner function):
1098     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
1099     # - PYTHON_SCRIPTS_DIR - Path to directory holding Python scripts.
1100     # Variables written:
1101     # - WORKING_TOPOLOGY - Set to empty string on successful unreservation.
1102     # Trap unregistered:
1103     # - EXIT - Failure to untrap is reported, but ignored otherwise.
1104     # Functions called:
1105     # - die - Print to stderr and exit.
1106     # - ansible_playbook - Perform an action using ansible, see ansible.sh
1107
1108     set -xo pipefail
1109     set +eu  # We do not want to exit early in a "teardown" function.
1110     trap - EXIT || echo "Trap deactivation failed, continuing anyway."
1111     wt="${WORKING_TOPOLOGY}"  # Just to avoid too long lines.
1112     if [[ -z "${wt-}" ]]; then
1113         set -eu
1114         warn "Testbed looks unreserved already. Trap removal failed before?"
1115     else
1116         ansible_playbook "cleanup" || true
1117         python3 "${PYTHON_SCRIPTS_DIR}/topo_reservation.py" -c -t "${wt}" || {
1118             die "${1:-FAILED TO UNRESERVE, FIX MANUALLY.}" 2
1119         }
1120         WORKING_TOPOLOGY=""
1121         set -eu
1122     fi
1123 }
1124
1125
1126 function warn () {
1127
1128     # Print the message to standard error.
1129     #
1130     # Arguments:
1131     # - ${@} - The text of the message.
1132
1133     set -exuo pipefail
1134
1135     echo "$@" >&2
1136 }